--- ie_func.c	2002-02-15 02:13:14.000000000 -0500
+++ ie_func.c	2014-12-27 03:48:01.000000000 -0500
@@ -42,4 +42,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <unistd.h>
 
 #if HAVE_STRING_H
@@ -75,10 +76,10 @@ FCT (static void, MatchedAt, (Text *text
 **	Function name : ie_current_position
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput : Le numero de la position courante (debut = 0)
 */
-int  ie_current_position ( text ) 
-    Text *text;
+int  ie_current_position ( text )
+    const Text *text;
 {
     return ( text -> buf -> l_cur - text -> buf -> top );
@@ -88,10 +89,10 @@ int  ie_current_position ( text ) 
 **	Function name : ie_current_char
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput : Le caractere courant ou 0 si fin de fichier
 */
 char ie_current_char ( text )
-    Text *text;
+    const Text *text;
 {
     return ( ( (text -> buf -> r_cur) == text -> buf -> bottom ) ?
@@ -102,10 +103,10 @@ char ie_current_char ( text )
 **	Function name : ie_previous_char
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput : Le caractere precedent, 0 si debut de buffer.
 */
 char ie_previous_char ( text )
-    Text *text;
+    const Text *text;
 {
     return ( ( text -> buf -> l_cur <= text -> buf -> top ) ?
@@ -116,10 +117,10 @@ char ie_previous_char ( text )
 **	Function name : ie_next_char
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput : le caractere suivant, 0 en fin de fichier
 */
 char ie_next_char ( text )
-    Text *text;
+    const Text *text;
 {
     return ( ( text -> buf -> r_cur + 1) == text -> buf -> bottom ) ?
@@ -130,10 +131,10 @@ char ie_next_char ( text )
 **	Function name : ie_the_char
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput : le caractere correspondant a la position, 0 si erreur
 */
 char ie_the_char (text, p)
-    Text *text;
+    const Text *text;
     int p;
 {
@@ -160,21 +161,21 @@ char ie_the_char (text, p)
 **	Function name : ie_beginning_of_line
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput : la position du debut de ligne
 */
 int ie_beginning_of_line( text )
-    Text *text;
+    const Text *text;
 {
     int pos = ie_current_position ( text );
-    
+
     if (pos)
       pos -= GetNcFromLeft ( text -> buf );
-    
+
     return (pos);
-/*    
+/*
     return ( (ie_current_position ( text ) == 0) ? 0 :
 	    ie_current_position ( text ) - GetNcFromLeft ( text -> buf ));
-*/	    
+*/
 }
 
@@ -182,16 +183,16 @@ int ie_beginning_of_line( text )
 **	Function name : ie_end_of_line
 **
-**	Description : 
-**	Input :  
+**	Description :
+**	Input :
 **	Ouput : la position de la fin de ligne
 **         Position du return ou fin de fichier.
 */
 int ie_end_of_line ( text )
-    Text *text;
+    const Text *text;
 {
     if ( ie_current_char ( text ) == '\n' )
       return ( ie_current_position ( text ));
     else {
-	return ( ie_current_position ( text ) 
+	return ( ie_current_position ( text )
 		+ GetNcFromRight ( text -> buf ));
     }
@@ -201,12 +202,12 @@ int ie_end_of_line ( text )
 **	Function name : ie_at_end_of_file
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :  True si fin de fichier.
 */
 int ie_at_end_of_file ( text )
-    Text *text;
+    const Text *text;
 {
-    if ( ie_current_char ( text ) == 0 )
+    if ( ie_current_char ( text ) == '\0' )
       return True;
     else
@@ -217,10 +218,10 @@ int ie_at_end_of_file ( text )
 **	Function name : ie_end_of_file
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :  la position de la fin de fichier
 */
 int ie_end_of_file ( text )
-    Text *text;
+    const Text *text;
 {
     return ( ( text -> buf -> l_cur - text -> buf -> top ) +
@@ -489,10 +490,10 @@ void ie_replace_char ( text, c )
 **      Function name : ie_end_of_region
 **
-**      Description : 
-**      Input : 
+**      Description :
+**      Input :
 **      Ouput :
 */
 int ie_end_of_region ( text )
-    Text *text;
+    const Text *text;
 {
     return ( ie_current_position (text) -1);
@@ -655,19 +656,19 @@ void ie_blink ( text, pos )
 **	Function name : ie_cmd_shell
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_cmd_shell ( text, str )
     Text *text;
-    char *str;
+    const char *str;
 {
 #define BIG_LINE 2048
-    
+
     FILE *fd;
     char tmp[BIG_LINE];
     int len;
     int modif_flag = False;
-    
+
     if ( (fd = popen ( str,  "r")) == NULL ) {
 	(void) fprintf ( stderr, "popen error\n" );
@@ -716,11 +717,11 @@ static void MatchedAt ( text, c, lines, 
 **	Function name : ie_msearch
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_msearch (text, chars, end, direction)
     Text * text;
-    char * chars;
+    const char * chars;
     int end;
     int direction;
@@ -751,11 +752,10 @@ int ie_msearch (text, chars, end, direct
 **	Function name : ie_create_mode
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput : Le nouveau mode sinon 0.
 */
-Mode *ie_create_mode ( text, mode_name )
-    Text *text;
-    char *mode_name;
+Mode *ie_create_mode ( mode_name )
+    const char *mode_name;
 {
     if ( mode_name == 0 )
@@ -769,21 +769,20 @@ Mode *ie_create_mode ( text, mode_name )
 **	Function name : ie_set_mode_suffixes
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
-void ie_set_mode_suffixes ( text, mode_name, suf )
-    Text *text;
-    char *mode_name;
-    char *suf;
+void ie_set_mode_suffixes (mode_name, suf)
+    const char *mode_name;
+    const char *suf;
 {
     Mode *mode;
-    
+
     if ( (mode_name == 0) || (suf == 0))
       return;
-    
+
     if ( (mode = (Mode*) GetMode ( mode_name )) == 0 )
       return;
-    
+
     SetModeSuffixe ( mode, suf );
 }
@@ -793,12 +792,11 @@ void ie_set_mode_suffixes ( text, mode_n
 **	Function name : ie_set_mode_font
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
-void ie_set_mode_font ( text, mode_name, font_name )
-    Text *text;
-    char *mode_name;
-    char *font_name;
+void ie_set_mode_font (mode_name, font_name)
+    const char *mode_name;
+    const char *font_name;
 {
     Mode *mode;
@@ -806,13 +804,13 @@ void ie_set_mode_font ( text, mode_name,
     if ( (mode_name == 0) || (font_name == 0) )
       return;
-    
-    if ( (mode = (Mode*) GetMode ( mode_name )) == 0 )
+
+    if ( (mode = GetMode ( mode_name )) == 0 )
       return;
-     
+
     SetModeFont ( mode, font_name );
 }
 
-unsigned key_code( keys )
-    unsigned char *keys;
+static unsigned key_code( keys )
+    const char *keys;
 {
   if (keys[0] == '^')
@@ -848,9 +846,8 @@ unsigned key_code( keys )
 **	Ouput :
 */
-void ie_key_def ( text, mode_name, keys, func_name )
-	Text *text;
-	char *mode_name;
-	unsigned char *keys;
-	char *func_name;
+void ie_key_def (mode_name, keys, func_name)
+	const char *mode_name;
+	const char *keys;
+	const char *func_name;
 {
     Mode *mode;
@@ -978,11 +975,11 @@ void ie_key_def ( text, mode_name, keys,
     }
 }
-    
+
 int ie_last_key (text)
-    Text *text;
+    const Text *text;
 {
     extern int last_key;
- 
-    if ( text != 0 )
+
+    if (text != NULL)
       return (last_key);
     else
@@ -1009,10 +1006,10 @@ void ie_current_line_to_top ( text )
 **	Function name : ie_line_count
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_line_count ( text )
-    Text *text;
+    const Text *text;
 {
     return ( text -> lines_in_buf );
@@ -1023,10 +1020,10 @@ int ie_line_count ( text )
 **	Function name : ie_current_line
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_current_line ( text )
-    Text *text;
+    const Text *text;
 {
     return ( text -> no_current_line - 1 );
@@ -1036,20 +1033,20 @@ int ie_current_line ( text )
 **	Function name : ie_backward_search
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_backward_search ( text, str )
     Text *text;
-    char *str;
+    const char *str;
 {
     int newpos, oldpos;
     char *start,  *end;
     int len;
-    
+
     oldpos = GetNcFromRight ( text -> buf );
-    start = (char *) GetCurrentLine ( text -> buf, &len );
-    end = (char *) TopBuf ( text -> buf );
-    
+    start = GetCurrentLine ( text -> buf, &len );
+    end = TopBuf ( text -> buf );
+
     start += ( len -1);	/* On part de la fin de la ligne */
 
@@ -1061,9 +1058,9 @@ int ie_backward_search ( text, str )
 	}
     }
-    start = (char *) LeftBuf ( text -> buf ); /* Allons voir plus loin */
-    
+    start = LeftBuf ( text -> buf ); /* Allons voir plus loin */
+
     if ( (newpos=BmSearch ( start, str,  start - end, BACKWARD )) == -1 )
       return False;
-    
+
     ie_goto_char ( text, ie_current_position ( text ) - newpos );
 
@@ -1075,17 +1072,17 @@ int ie_backward_search ( text, str )
 **	Function name : ie_forward_search
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_forward_search ( text, str )
     Text *text;
-    char *str;
+    const char *str;
 {
     int newpos;
     char *start, *end;
-    
-    start = (char *) RightBuf ( text -> buf ); 
-    end = (char *) BottomBuf ( text -> buf );
+
+    start = RightBuf ( text -> buf );
+    end = BottomBuf ( text -> buf );
 
     if ( (newpos=BmSearch( start, str,  end -start, FORWARD )) != -1 ) {
@@ -1112,14 +1109,14 @@ int ie_forward_search ( text, str )
 **	Function name : ie_global_replace
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput : Le nombre de subtitutions.
 */
 int ie_global_replace ( text, old, new )
     Text *text;
-    char *old, *new;
+    const char *old, *new;
 {
     int i = 0;
-    
+
     if ( (old != 0) && (new != 0) && (strlen(old) != 0)) {
       if (strchr(old, '\n') || strchr(new, '\n')) {
@@ -1127,9 +1124,9 @@ int ie_global_replace ( text, old, new )
 	int pos = ie_current_position(text);
 	int lgo = strlen(old);
-	
+
 	while (ie_forward_search(text, old)) {
 	  int i;
-	  char * n;
-	  
+	  const char * n;
+
 	  for (i = 0; i != lgo; i += 1)
 	    ie_delete_char(text);
@@ -1137,5 +1134,5 @@ int ie_global_replace ( text, old, new )
 	    ie_insert_char(text, *n);
 	}
-	
+
 	ie_goto_char(text, pos);
       }
@@ -1154,11 +1151,11 @@ int ie_global_replace ( text, old, new )
 **	Function name : ie_read_file
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_read_file ( text, filename )
     Text *text;
-    char *filename;
+    const char *filename;
 {
     extern Display *dpy;
@@ -1193,11 +1190,11 @@ int ie_read_file ( text, filename )
 **	Function name : ie_insert_file
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_insert_file ( text, filename )
     Text *text;
-    char *filename;
+    const char *filename;
 {
     int nbl, olen;
@@ -1207,23 +1204,23 @@ int ie_insert_file ( text, filename )
     if (text -> selection -> select == True)
       ClearSelection(text, True);
-    
+
     TextCursorOff ( text );
     nbl = text -> lines_in_buf;
     olen = BottomBuf (text -> buf) - RightBuf (text -> buf);
-    
+
     if ( LoadFile ( text, filename,  INSERT ) != -1 ) {
-	SetTextModif ( text );		
-	SetAndDisplayPage ( text ); 
+	SetTextModif ( text );
+	SetAndDisplayPage ( text );
 	ShowScrollFrame ( dpy, text -> swin );
-	(void) MoveScrollBar ( dpy, text -> swin, 
+	(void) MoveScrollBar ( dpy, text -> swin,
 			      CURRENT, text -> no_current_line - text -> n1 - 1 );
 	x_len = (BottomBuf (text -> buf) - RightBuf (text -> buf)) - olen;
 	StoreInUndo ( text, RightBuf (text -> buf) , (char *) 0, x_len,
 		     text -> lines_in_buf - nbl, U_INSERT );
-    
+
 	/* Pour la couleur */
 	if ( text -> current_ce != 0 )
 	  (void) UpdateColorList ( text, x_len );
-	
+
 	TextCursorOn ( text );
 	text -> ie_mark = True;
@@ -1240,14 +1237,14 @@ int ie_insert_file ( text, filename )
 **	Function name : ie_file_select
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
-char *ie_file_select ( text )
+const char *ie_file_select ( text )
     Text *text;
 {
-    char *str;
+    const char *str;
     char c = '\007'; /* ^G */
-    
+
     if (text -> selection -> select == True){
       SetCurrentLine (text);
@@ -1255,6 +1252,6 @@ char *ie_file_select ( text )
     }
 
-    str = (char *) SelectFileFromBox ( "Select file from Smac." );
-    if ( (str == 0) || (strncmp(str, &c, 1)) == 0 ) {
+    str = SelectFileFromBox ( "Select file from Smac." );
+    if ( (str == NULL) || (strncmp(str, &c, 1)) == 0 ) {
 /*	if ( str != 0 )
 	  (void) free ( str ); */
@@ -1271,11 +1268,11 @@ char *ie_file_select ( text )
 **	Function name : ie_write_file
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 void ie_write_file ( text, filename )
     Text *text;
-    char *filename;
+    const char *filename;
 {
     extern int write_flag;
@@ -1309,15 +1306,9 @@ void ie_save_file ( text )
     Text *text;
 {
-    char *tmp;
-    
-    if (text -> filename) {
-      tmp = (char *) malloc(MAXPATHLEN+2);
-      (void) strcpy(tmp, text -> filename);
-    }
-    else
+
+    if (text->filename == NULL)
       return;
-    
-    (void) ie_write_file ( text, tmp );
-    (void) free(tmp);
+
+    (void) ie_write_file (text, text->filename);
 }
 
@@ -1325,10 +1316,10 @@ void ie_save_file ( text )
 **	Function name : ie_current_buffer_is_modified
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_current_buffer_is_modified ( text )
-    Text *text;
+    const Text *text;
 {
   return GetModif( text );
@@ -1339,13 +1330,13 @@ int ie_current_buffer_is_modified ( text
 **	Function name : ie_filename
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
-char *ie_filename ( text )
-    Text *text;
+const char *ie_filename ( text )
+    const Text *text;
 {
     if ( strcmp ( text -> filename, "NoName" ) == 0 )
-      return 0;
+      return NULL;
     else
       return ( text -> filename );
@@ -1356,10 +1347,10 @@ char *ie_filename ( text )
 **	Function name : ie_window_height
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_window_height ( text )
-    Text *text;
+    const Text *text;
 {
     return ( text -> lines_in_page );
@@ -1370,19 +1361,19 @@ int ie_window_height ( text )
 **	Function name : ie_window_width
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_window_width ( text, ch )
-    Text *text;
+    const Text *text;
     int ch;
 {
     char c = (char) ch;
-    
+
     int width = XTextWidth ( text -> font, &c, 1 );
-    
+
     if (width)
       return ( (text -> width - (2 * text -> x_or)) / width);
-    
+
     return (- ((text -> width - (2 * text -> x_or))));
 }
@@ -1391,10 +1382,10 @@ int ie_window_width ( text, ch )
 **	Function name : ie_current_window
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_current_window ( text )
-    Text *text;
+    const Text *text;
 {
     return ( text -> win_id );
@@ -1404,15 +1395,15 @@ int ie_current_window ( text )
 **	Function name : ie_new_window
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 int ie_new_window ( text )
-    Text *text;
+    const Text *text;
 {
     EdWin *tmp;
-    
+
     tmp = (EdWin *) CreateWindow ();
-    
+
     if ( tmp != 0 ) {
 	tmp -> text -> current_mode = (Mode *) GetMode ("default");
@@ -1421,8 +1412,8 @@ int ie_new_window ( text )
 	tmp -> text -> ie_mark = True;
 	(void) strcpy ( tmp -> text -> current_dir, text -> current_dir );
-	
+
 	WaitForMapped ( tmp -> text -> window, True );
-	StorePosition ( tmp -> text );   
-	
+	StorePosition ( tmp -> text );
+
 	return ( tmp -> text -> win_id );
     }
@@ -1436,14 +1427,13 @@ int ie_new_window ( text )
 **	Function name : ie_select_window
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
-Text *ie_select_window ( text, win_id )
-    Text *text;
+Text *ie_select_window (win_id)
     int win_id;
 {
     extern EdWin *TWin[];
-    
+
     if ( (win_id <0) || (win_id > (MAXWIN - 1)))
       return 0;
@@ -1523,15 +1513,15 @@ void ie_lower_window ( text )
 **	Function name : ie_raise_window
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 void ie_raise_window (text)
-    Text *text;
+    const Text *text;
 {
     extern Display *dpy;
-    
+
     int win_id = ie_current_window ( text );
-    
+
     if ( TWin [win_id] != 0 )
       XMapRaised ( dpy, text -> w_parent );
@@ -1542,35 +1532,35 @@ void ie_raise_window (text)
 **	Function name : ie_set_mode
 **
-**	Description : 
-**	Input : 
+**	Description :
+**	Input :
 **	Ouput :
 */
 void ie_set_mode ( text, name )
     Text *text;
-    char *name;
+    const char *name;
 {
     char *buf;
     Mode *new_mode = (Mode *) GetMode (name);
-    
+
     if ( new_mode == 0 ) {
-	buf = (char *) malloc ( (unsigned int) strlen (name) + 64 );
+	buf = malloc ( (unsigned int) strlen (name) + 64 );
 	(void) sprintf ( buf, "Warning : %s mode does not exist", name );
 	DisplayMessage ( text -> mwin, buf );
-	(void) free (buf);
+	free (buf);
 	return;
     }
-    
+
     if ( strcmp(text -> current_mode -> name, name) == 0 )
       return;
-    
+
     if ( strcmp ( name, "Shell" ) == 0 ) {
 	SetShellMode ( text );
 	return;
     }
-    
+
     if ( text -> shell_id != 0 )
       KillShell ( text );
     text -> current_mode = new_mode;
-    
+
     SetCtrMode ( text -> mwin, text -> current_mode );
     RefreshWindowMode ( text -> mwin );
@@ -1588,8 +1578,8 @@ void ie_set_mode ( text, name )
 void ie_set_font ( text, font_name )
     Text *text;
-    char *font_name;
+    const char *font_name;
 {
     XFontStruct *font;
-    
+
     if ((font = (XFontStruct *) XLoadQueryFont ( dpy, font_name )) == 0 ) {
       (void) DisplayWMessage ( "fontname unknown", "Change current font", True );
@@ -1612,8 +1602,8 @@ void ie_set_font ( text, font_name )
 int ie_re_search_forward ( text, regex )
     Text *text;
-    char *regex;
+    const char *regex;
 {
     int current_pos = ie_current_position(text);
-    
+
     int result = RE_Search ( regex, RightBuf(text->buf),
 			BottomBuf(text->buf) - RightBuf(text->buf) + 1, FORWARD);
@@ -1640,9 +1630,9 @@ int ie_re_search_forward ( text, regex )
 int ie_re_search_backward ( text, regex )
     Text *text;
-    char *regex;
+    const char *regex;
 {
     int result = RE_Search ( regex, TopBuf(text->buf),
 			    LeftBuf(text->buf) - TopBuf(text->buf) + 1, BACKWARD);
-  
+
     if ( result < 0 )
       return result;
@@ -1665,5 +1655,5 @@ int ie_re_search_backward ( text, regex 
 int ie_re_replace ( text, regex, newstring )
     Text *text;
-    char *regex, *newstring;
+    const char *regex, *newstring;
 {
     int result;
@@ -1685,5 +1675,5 @@ int ie_re_replace ( text, regex, newstri
 int ie_re_replace_match ( text, newstring )
     Text *text;
-    char *newstring;
+    const char *newstring;
 {
     int result = RE_ReplaceMatch ( text, newstring );
@@ -1699,6 +1689,5 @@ int ie_re_replace_match ( text, newstrin
 **	Output :
 */
-int ie_re_match_beginning ( text, n)
-    Text *text;
+int ie_re_match_beginning (n)
     int n;
 {
@@ -1713,6 +1702,5 @@ int ie_re_match_beginning ( text, n)
 **	Output :
 */
-int ie_re_match_end ( text, n)
-    Text *text;
+int ie_re_match_end (n)
     int n;
 {
@@ -1726,9 +1714,8 @@ int ie_re_match_end ( text, n)
 **	Input : La commande shell.
 **	Ouput : La resultat de la commande (sans le '\n') ou 0 si erreur.
-**        le resultat doit etre libere par le client.  
+**        le resultat doit etre libere par le client.
 */
-char *ie_shell_to_string ( text, str )
-    Text *text;
-    char *str;
+char *ie_shell_to_string (str)
+    const char *str;
 {
     FILE *fd;
@@ -1737,5 +1724,5 @@ char *ie_shell_to_string ( text, str )
     int len, t_len = 0;
     char *pp, *ptr = 0;
-    
+
     if ( (fd = popen ( str,  "r")) == NULL ) {
       (void) DisplayWMessage ( "Shell command", "Popen error", True );
@@ -1746,5 +1733,5 @@ char *ie_shell_to_string ( text, str )
 	while (fgets ( tmp,MAX_LINE, fd ) != 0 ) {
 	    len = strlen(tmp);
-	    pp = (char *) malloc ((unsigned) len+t_len+1);
+	    pp = malloc ((unsigned) len+t_len+1);
 	    bzero(pp, len+t_len+1);
 	    if(ptr && t_len)
@@ -1753,5 +1740,5 @@ char *ie_shell_to_string ( text, str )
 	    t_len += len;
 	    if (ptr)
-	      (void) free(ptr);
+	      free(ptr);
 	    ptr = pp;
 	}
@@ -1761,5 +1748,5 @@ char *ie_shell_to_string ( text, str )
     if ((ptr != 0) && ptr[strlen(ptr)-1] == '\n')
       ptr[strlen(ptr)-1] = 0;
-    
+
     return (ptr);
 }
@@ -1777,10 +1764,10 @@ void ie_set_mark ( text, pos )
 {
     int current;
-    
+
     if (pos <0)
       return;
 
     current = ie_current_position (text);
-    
+
     (void) ie_goto_char(text,pos);
     text -> markline = text -> no_current_line;
@@ -1840,8 +1827,8 @@ void ie_color_area ( text, start, end, c
     Text *text;
     int start, end;
-    char *colorname;
+    const char *colorname;
 {
     extern Display *dpy;
-    
+
     if ( DefaultDepth ( dpy, DefaultScreen ( dpy )) == 1 )
       return;
@@ -1928,5 +1915,5 @@ void ie_remove_colors ( text )
 */
 int ie_current_buffer_is_colored ( text )
-    Text *text;
+    const Text *text;
 {
   return (text->current_ce != 0);
@@ -1941,5 +1928,5 @@ int ie_current_buffer_is_colored ( text 
 */
 void ie_watch_on(text)
-    Text *text;
+    const Text *text;
 {
   WatchOn (text -> window);
@@ -1954,5 +1941,5 @@ void ie_watch_on(text)
 */
 void ie_watch_off(text)
-    Text *text;
+    const Text *text;
 {
   WatchOff (text -> window);
@@ -1966,6 +1953,5 @@ void ie_watch_off(text)
 **	Output :
 */
-void ie_usleep(text, t)
-    Text *text;
+void ie_usleep(t)
     int t;
 {
@@ -1984,9 +1970,9 @@ void ie_usleep(text, t)
 **	Output : le nom du mode courrant. (doit etre libere)
 */
-char *ie_current_mode(text)
+const char *ie_current_mode(text)
     Text *text;
 {
   if (text -> current_mode -> name)
-    return ((char *) text -> current_mode -> name);
+    return (text -> current_mode -> name);
   else
     return 0;
@@ -2000,6 +1986,5 @@ char *ie_current_mode(text)
 **	Output :
 */
-int ie_monochrome(text)
-	Text *text;
+int ie_monochrome()
 {
         extern Display *dpy;
@@ -2023,7 +2008,7 @@ int ie_set_tab_width (new_width)
   int old;
   EdWin **t;
-  extern int tab_width;  
+  extern int tab_width;
   extern Display *dpy;
-  
+
   old=tab_width;
   if (new_width <= 0)
--- ie_func.h	2002-02-15 02:07:29.000000000 -0500
+++ ie_func.h	2014-12-27 03:47:35.000000000 -0500
@@ -44,23 +44,23 @@
 #include "proto_decl.h"
 
-FCT (int, ie_at_end_of_file, (Text *text) );
-FCT (int, ie_backward_search, (Text *text, char *str) );
-FCT (int, ie_beginning_of_line, (Text *text) );
+FCT (int, ie_at_end_of_file, (const Text *text) );
+FCT (int, ie_backward_search, (Text *text, const char *str) );
+FCT (int, ie_beginning_of_line, (const Text *text) );
 FCT (void, ie_blink, (Text *text, int pos) );
-FCT (int, ie_cmd_shell, (Text *text, char *str) );
-FCT (Mode *, ie_create_mode, (Text *text, char *mode_name) );
-FCT (char, ie_current_char, (Text *text) );
-FCT (int, ie_current_line, (Text *text) );
+FCT (int, ie_cmd_shell, (Text *text, const char *str) );
+FCT (Mode *, ie_create_mode, (const char *mode_name) );
+FCT (char, ie_current_char, (const Text *text) );
+FCT (int, ie_current_line, (const Text *text) );
 FCT (void, ie_current_line_to_top, (Text *text) );
-FCT (int, ie_current_position, (Text *text) );
-FCT (int, ie_current_window, (Text *text) );
+FCT (int, ie_current_position, (const Text *text) );
+FCT (int, ie_current_window, (const Text *text) );
 FCT (void, ie_delete_char, (Text *text) );
-FCT (int, ie_end_of_file, (Text *text) );
-FCT (int, ie_end_of_line, (Text *text) );
-FCT (int, ie_end_of_region, (Text *text) );
-FCT (char *, ie_file_select, (Text *text) );
-FCT (char *, ie_filename, (Text *text) );
-FCT (int, ie_forward_search, (Text *text, char *str) );
-FCT (int, ie_global_replace, (Text *text, char *old, char *new) );
+FCT (int, ie_end_of_file, (const Text *text) );
+FCT (int, ie_end_of_line, (const Text *text) );
+FCT (int, ie_end_of_region, (const Text *text) );
+FCT (const char *, ie_file_select, (Text *text) );
+FCT (const char *, ie_filename, (const Text *text) );
+FCT (int, ie_forward_search, (Text *text, const char *str) );
+FCT (int, ie_global_replace, (Text *text, const char *old, const char *new) );
 FCT (void, ie_goto_beginning_of_line, (Text *text) );
 FCT (void, ie_goto_char, (Text *text, int p) );
@@ -70,49 +70,55 @@ FCT (void, ie_goto_next_char, (Text *tex
 FCT (void, ie_goto_previous_char, (Text *text) );
 FCT (void, ie_insert_char, (Text *text, int c) );
-FCT (int, ie_insert_file, (Text *text, char *filename) );
-FCT (void, ie_key_def, (Text *text, char *mode_name, unsigned char *keys, char *func_name) );
+FCT (int, ie_insert_file, (Text *text, const char *filename) );
+FCT (void, ie_key_def, (const char *mode_name, const char *keys, const char *func_name) );
 FCT (void, ie_kill_current_buffer, (Text *text) );
 FCT (int, ie_kill_window, (Text *text, int num) );
-FCT (int, ie_last_key, (Text *text) );
-FCT (int, ie_line_count, (Text *text) );
+FCT (int, ie_last_key, (const Text *text) );
+FCT (int, ie_line_count, (const Text *text) );
 FCT (void, ie_lower_window, (Text *text) );
 FCT (int, ie_mark_position, (Text *text) );
-FCT (int, ie_msearch, (Text *text, char *chars, int end, int direction) );
-FCT (int, ie_new_window, (Text *text) );
-FCT (char, ie_next_char, (Text *text) );
-FCT (char, ie_previous_char, (Text *text) );
-FCT (int, ie_read_file, (Text *text, char *filename) );
+FCT (int, ie_msearch, (Text *text, const char *chars, int end, int direction) );
+FCT (int, ie_new_window, (const Text *) );
+FCT (char, ie_next_char, (const Text *text) );
+FCT (char, ie_previous_char, (const Text *text) );
+FCT (int, ie_read_file, (Text *text, const char *filename) );
 FCT (void, ie_redisplay, (Text *text) );
 FCT (void, ie_replace_char, (Text *text, int c) );
 FCT (void, ie_save_file, (Text *text) );
-FCT (Text *, ie_select_window, (Text *text, int win_id) );
-FCT (void, ie_set_mode, (Text *text, char *name) );
-FCT (void, ie_set_mode_font, (Text *text, char *mode_name, char *font_name) );
-FCT (void, ie_set_mode_suffixes, (Text *text, char *mode_name, char *suf) );
-FCT (char, ie_the_char, (Text *text, int p) );
+FCT (Text *, ie_select_window, (int win_id) );
+FCT (void, ie_set_mode, (Text *text, const char *name) );
+FCT (void, ie_set_mode_font, (const char *mode_name, const char *font_name) );
+FCT (void, ie_set_mode_suffixes, (const char *mode_name, const char *suf) );
+FCT (char, ie_the_char, (const Text *text, int p) );
 FCT (void, ie_upper_window, (Text *text) );
-FCT (int, ie_window_height, (Text *text) );
-FCT (int, ie_window_width, (Text *text, int c) );
-FCT (void, ie_set_font, (Text *text, char *font) );
-FCT (int, ie_re_search_forward, (Text *text, char *regex ) );
-FCT (int, ie_re_search_backward, (Text *text, char *regex ) );
-FCT (int, ie_re_replace, (Text *text, char *regex, char* newstring ) );
-FCT (int, ie_re_replace_match, (Text *text, char *newstring ) );
-FCT (int, ie_re_match_beginning, (Text *text, int n) );
-FCT (int, ie_re_match_end, (Text *text, int n) );
-FCT (char *, ie_shell_to_string, (Text *text, char *str ) );
+FCT (int, ie_window_height, (const Text *text) );
+FCT (int, ie_window_width, (const Text *text, int c) );
+FCT (void, ie_set_font, (Text *text, const char *font) );
+FCT (int, ie_re_search_forward, (Text *text, const char *regex ) );
+FCT (int, ie_re_search_backward, (Text *text, const char *regex ) );
+FCT (int, ie_re_replace, (Text *text, const char *regex, const char* newstring ) );
+FCT (int, ie_re_replace_match, (Text *text, const char *newstring ) );
+FCT (int, ie_re_match_beginning, (int n) );
+FCT (int, ie_re_match_end, (int n) );
+FCT (char *, ie_shell_to_string, (const char *str) );
 FCT (void, ie_set_mark, (Text *text, int pos ) );
 FCT (void, ie_goto_mark, (Text *text ) );
 FCT (void, ie_reset_mark, (Text *text ) );
-FCT (void, ie_color_area, (Text *text, int start, int end, char *colorname ) );
+FCT (void, ie_color_area, (Text *text, int start, int end, const char *colorname ) );
 FCT (void, ie_uncolor_area, (Text *text, int start, int end) );
 FCT (void, ie_paste_region, (Text *text ) );
 FCT (void, ie_copy_region, (Text *text ) );
 FCT (void, ie_cut_region, (Text *text ) );
-FCT (void, ie_watch_on, (Text *text ) );
-FCT (void, ie_watch_off, (Text *text ) );
-FCT (void, ie_usleep, (Text *text, int t ) );
-FCT (char *, ie_current_mode, (Text *text ) );
+FCT (void, ie_watch_on, (const Text *text ) );
+FCT (void, ie_watch_off, (const Text *text ) );
+FCT (void, ie_usleep, (int t ) );
+FCT (const char *, ie_current_mode, (Text *text ) );
 FCT (int, ie_set_tab_width, ( int w ) );
+FCT (int, ie_monochrome, (void) );
+FCT (void, ie_write_file, (Text *, const char *filename) );
+FCT (int, ie_current_buffer_is_modified, (const Text *) );
+FCT (void, ie_raise_window, (const Text *) );
+FCT (void, ie_remove_colors, (Text *) );
+FCT (int, ie_current_buffer_is_colored, (const Text *) );
 
 #endif /* _IE_FUNC_H_ */
